\
@echo off
set LOGFILE=%~dp0reset_log.txt

:: Check for elevated session
net session >nul 2>&1
if %errorlevel% neq 0 (
    echo CLEAN RESET LOG - %DATE% %TIME% > "%LOGFILE%"
    echo Elevating privileges... >> "%LOGFILE%"
    powershell -Command "Start-Process '%~f0' -ArgumentList 'elevated' -Verb RunAs"
    exit /b
)

:: Log from elevated session
if "%1"=="elevated" (
    echo Running as Administrator... >> "%LOGFILE%"

    :: Check BitLocker status
    echo Checking BitLocker status on drive C:... >> "%LOGFILE%"
    for /f "tokens=3" %%a in ('manage-bde -status C: ^| find "Protection Status"') do set status=%%a

    if /i "%status%"=="On" (
        echo BitLocker is ON. Disabling it... >> "%LOGFILE%"
        manage-bde -off C:
        echo Waiting for BitLocker to fully decrypt the drive... >> "%LOGFILE%"
        :loop
        timeout /t 5 > nul
        for /f "tokens=3" %%b in ('manage-bde -status C: ^| find "Percentage Encrypted"') do set progress=%%b
        echo Progress: %progress% encrypted >> "%LOGFILE%"
        echo %progress% | findstr "0.0%" >nul
        if errorlevel 1 goto loop
        echo BitLocker decryption complete. >> "%LOGFILE%"
    ) else (
        echo BitLocker is OFF. Continuing... >> "%LOGFILE%"
    )

    echo Enabling Windows Recovery Environment... >> "%LOGFILE%"
    reagentc /enable >> "%LOGFILE%" 2>&1

    echo Launching system reset tool... >> "%LOGFILE%"
    timeout /t 3
    start "" systemreset.exe -factoryreset

    echo Reset tool launched. If nothing appears, run it manually. >> "%LOGFILE%"
    pause
)
